package com.jscape.inet.ssh.protocol.v2.messages;

import com.jscape.inet.ssh.protocol.messages.Message;
import com.jscape.util.net.connection.MessageConnection;

import static com.jscape.util.Parameters.assertNotNull;

/**
 * @author Alex Usun
 */
public class SshMsgDisconnect
        extends Message<SshMsgDisconnect.Handler> {

    public final int reasonCode;
    public final String description;
    public final String languageTag;

    public SshMsgDisconnect(int reasonCode, String description, String languageTag) {
        this.reasonCode = reasonCode;

        assertNotNull(description);
        this.description = description;

        assertNotNull(languageTag);
        this.languageTag = languageTag;
    }

    public SshMsgDisconnect(DisconnectReason reason, String description, String languageTag) {
        this(reason.code, description, languageTag);
    }

    @Override
    public Class handlerClass() {
        return Handler.class;
    }

    @Override
    public void accept(Handler handler, MessageConnection<Message> connection) {
        handler.handle(this, connection);
    }

    @Override
    public String toString() {
        return "SshMsgDisconnect {"
                + "reasonCode=" + this.reasonCode
                + ", description='" + this.description + '\''
                + ", languageTag='" + this.languageTag + '\''
                + '}';
    }

    public interface Handler
            extends Message.HandlerBase {

        void handle(SshMsgDisconnect message, MessageConnection<Message> connection);

    }
}
